/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
/////TODO: There is a function which places wall tiles at the edge of the level, effectively decreasing the width and height.
//moet er eigenlijk niet ook een functie zijn die een rij walls kan plaatsen?
//moet een spook of pacman op een muntje kunnen worden gezet? of alleen andersom? of beide? nu kan alleen het eerste
/*
 * EditorGUI.java
 *
 * Created on 25-nov-2009, 15:08:23
 */
package biteme;

import java.awt.Dimension;
import java.awt.GridBagLayout;
import java.awt.Toolkit;
import javax.swing.ImageIcon;
import javax.swing.JFrame;

/**
 * Class for the GUI of the editor
 * @author s070693
 */
public class EditorGUI extends javax.swing.JFrame {

    ImageIcon symbol = new ImageIcon();
    JFrame parent;
    //int stupidghostcounter = 0;
    //int smartghostcounter = 0;
    private EditorTileType selectedTileType = EditorTileType.NONE;
    private EditorTileType selectedPreviousTileType;
    Tile oldT;
    String currentMazePath = null;
    String currentMazeName = null;

    /** Creates new form EditorGUI
     * @param pParent Parent window of this instance
     * @param mazeFilePath the filepath to the loaded maze
     */
    public EditorGUI(JFrame pParent, String mazeFilePath) {
        parent = pParent;
        initComponents();
        // set panel GamePanel as gridbaylayout
        this.GamePanel.setLayout(new GridBagLayout());

        this.GamePanel.validate();

        //icon
        setIconImage(Toolkit.getDefaultToolkit().getImage(MainMenu.class.getResource("biteme_icon.png")));
        setTitle("BiteMe - LevelEditor");        
        if (mazeFilePath == null) {
            MazeIO.emptyMaze(GamePanel);
        } else {
            currentMazePath = mazeFilePath;
            currentMazeName = MazeIO.getFileName(currentMazePath);
            if(mazeFilePath.endsWith(".ply")) {
                MazeIO.makeUnPlayable(currentMazePath);
                currentMazePath = Path.getMazesPath() + MazeIO.getFileName(currentMazePath) + ".unp";
            }
            MazeIO.loadMaze(GamePanel, currentMazePath);
            if (currentMazeName != null) {
                setTitle(currentMazeName);
            }
        }
        GamePanel.initialDraw();
        GamePanel.setParent(this);

        Dimension minSize = new Dimension(980, 900);
        this.setMinimumSize(minSize);
        this.setPreferredSize(minSize);
        this.validate();

    }

    void changeTileAt(int x, int y) {
        Status s = new Status();
        Tile t = GamePanel.getTile(x, y);
        s = t.getStatus();

        switch (selectedTileType) {
            case NONE:
                // Alles weghalen
                if (GamePanel.getPacman() != null && GamePanel.getPacman().getTile() == t) {
                    //pacman weghalen
                    GamePanel.setPacman(null);
                }
                if (t.containsGhost()) {
                    //ghost(s) weghalen
                    GamePanel.removeGhostsFromTile(t);
                }
                t = new EmptyTile(GamePanel, x, y);
                t.draw();
                break;
            case WALL:
                if (s.containsNothing() && !t.containsGhost() && (GamePanel.getPacman() == null || GamePanel.getPacman().getTile() != t)) {
                    //als vorige geselecteerde object ook een wall was en in dezelfde kolom                    
                    if (MultipleWalls.isSelected()) {
                        if (selectedPreviousTileType == EditorTileType.WALL && oldT != null && oldT.getLocationY() == y) {
                            for (int i = Math.min(oldT.getLocationX(), x); i < Math.max(oldT.getLocationX(), x); i++) {
                                s = GamePanel.getTile(i, y).getStatus();
                                t = GamePanel.getTile(i, y);
                                if (s.containsNothing() && !t.containsGhost() && (GamePanel.getPacman() == null || GamePanel.getPacman().getTile() != t)) {
                                    t = new WallTile(GamePanel, i, y);
                                    t.draw();
                                    GamePanel.setTile(t, i, y);
                                }
                            }
                        }//als vorige geselecteerde object ook een wall was en in dezelfde rij
                        else if (selectedPreviousTileType == EditorTileType.WALL && oldT != null && oldT.getLocationX() == x) {
                            for (int i = Math.min(oldT.getLocationY(), y); i < Math.max(oldT.getLocationY(), y); i++) {
                                s = GamePanel.getTile(x, i).getStatus();
                                t = GamePanel.getTile(x, i);
                                if (s.containsNothing() && !t.containsGhost() && (GamePanel.getPacman() == null || GamePanel.getPacman().getTile() != t)) {
                                    t = new WallTile(GamePanel, x, i);
                                    t.draw();
                                    GamePanel.setTile(t, x, i);
                                }
                            }
                        }
                    }
                    t = new WallTile(GamePanel, x, y);
                    t.draw();
                }
                break;
            case BOX:
                if (s.containsNothing() && !t.containsGhost() && (GamePanel.getPacman() == null || GamePanel.getPacman().getTile() != t)) {
                    t = new EmptyTile(GamePanel, x, y);
                    t.getStatus().setBox();
                    t.draw();
                }
                break;
            case COIN:
                if (t instanceof OneWayTile || s.containsNothing()) {
                    t.getStatus().toggleCoin();
                    if(GamePanel.getPacman() == null || GamePanel.getPacman().getTile() != t) {
                        t.draw();
                    }
                }
                break;
            case ONE_WAY_DOWN:
                if ((s.containsNothing() || s.containsCoin()) && !t.containsGhost() && (GamePanel.getPacman() == null || GamePanel.getPacman().getTile() != t)) {
                    t = new OneWayTile(GamePanel, x, y);
                    s.setOneWay(Direction.DOWN);
                    t.setStatus(s);
                    t.draw();
                }
                break;
            case ONE_WAY_UP:
                if ((s.containsNothing() || s.containsCoin()) && !t.containsGhost() && (GamePanel.getPacman() == null || GamePanel.getPacman().getTile() != t)) {
                    t = new OneWayTile(GamePanel, x, y);
                    s.setOneWay(Direction.UP);
                    t.setStatus(s);
                    t.draw();
                }
                break;
            case ONE_WAY_LEFT:
                if ((s.containsNothing() || s.containsCoin()) && !t.containsGhost() && (GamePanel.getPacman() == null || GamePanel.getPacman().getTile() != t)) {
                    t = new OneWayTile(GamePanel, x, y);
                    s.setOneWay(Direction.LEFT);
                    t.setStatus(s);
                    t.draw();
                }
                break;
            case ONE_WAY_RIGHT:
                if ((s.containsNothing() || s.containsCoin()) && !t.containsGhost() && (GamePanel.getPacman() == null || GamePanel.getPacman().getTile() != t)) {
                    t = new OneWayTile(GamePanel, x, y);
                    s.setOneWay(Direction.RIGHT);
                    t.setStatus(s);
                    t.draw();
                }
                break;
            case PACMAN:
                if (t instanceof OneWayTile || s.containsNothing() || s.containsCoin()) {
                    // als er nog geen pacman bestaat, nieuwe maken
                    if (GamePanel.getPacman() == null) {
                        PacmanEntity pacman = new PacmanEntity(GamePanel);
                        pacman.setTile(t);
                        GamePanel.setPacman(pacman);
                        pacman.draw();
                    } else { // als wel al een pacman bestaat, deze verplaatsen
                        GamePanel.getPacman().getTile().draw();
                        GamePanel.getPacman().setTile(t);
                        GamePanel.getPacman().draw();
                    }
                }
                break;
            case STUPID_GHOST:
                if ((s.containsNothing() || t instanceof OneWayTile || s.containsCoin()) && !t.containsGhost()) {
                    StupidGhost stupidghost = new StupidGhost(GamePanel);
                    stupidghost.setTile(t);
                    GamePanel.getStupidGhosts().add(0, stupidghost);
                    stupidghost.draw();
                }
                break;
            case SMART_GHOST:
                if ((s.containsNothing() || t instanceof OneWayTile || s.containsCoin()) && !t.containsGhost()) {
                    SmartGhost smartghost = new SmartGhost(GamePanel);
                    smartghost.setTile(t);
                    GamePanel.getSmartGhosts().add(0, smartghost);
                    smartghost.draw();
                }
                break;
        }
        //adds the tile to the maze
        GamePanel.setTile(t, x, y);
        selectedPreviousTileType = selectedTileType;
        oldT = t;
    }

    void removeTileAt(int x, int y) {
        Tile t = GamePanel.getTile(x, y);
        // als oneway met muntje, alleen muntje weghalen  
        if (t.getStatus().containsCoin() && t instanceof OneWayTile) {
            t.getStatus().clearCoin();            
        } // als spook met muntje, alleen muntje weghalen          
        else if (t.getStatus().containsCoin() && t.containsGhost()) {
            t.getStatus().clearCoin();
        } else {
            // Alles weghalen
            if (GamePanel.getPacman() != null && GamePanel.getPacman().getTile() == t) {
                //pacman weghalen
                GamePanel.setPacman(null);
            }
            if (t.containsGhost()) {
                //ghost(s) weghalen
                GamePanel.removeGhostsFromTile(t);
            }
            t = new EmptyTile(GamePanel, x, y);            
        }
        t.draw();
        GamePanel.setTile(t, x, y);
        selectedPreviousTileType = EditorTileType.NONE;
        oldT = t;
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        GamePanel = new biteme.Maze();
        Wall = new javax.swing.JButton();
        OneWayD = new javax.swing.JButton();
        OneWayL = new javax.swing.JButton();
        OneWayR = new javax.swing.JButton();
        OneWayU = new javax.swing.JButton();
        Pacman = new javax.swing.JButton();
        SmartGhost = new javax.swing.JButton();
        StupidGhost = new javax.swing.JButton();
        Box = new javax.swing.JButton();
        Coin = new javax.swing.JButton();
        Empty = new javax.swing.JButton();
        FillCoins = new javax.swing.JButton();
        MultipleWalls = new javax.swing.JCheckBox();
        RemoveCoins = new javax.swing.JButton();
        jPanel1 = new javax.swing.JPanel();
        Test = new javax.swing.JButton();
        Load_File = new javax.swing.JButton();
        Reset = new javax.swing.JButton();
        Temp_Save = new javax.swing.JButton();
        Main_Menu_button = new javax.swing.JButton();
        jButton1 = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setResizable(false);

        GamePanel.setBackground(new java.awt.Color(0, 0, 0));
        GamePanel.setPreferredSize(new java.awt.Dimension(960, 660));

        javax.swing.GroupLayout GamePanelLayout = new javax.swing.GroupLayout(GamePanel);
        GamePanel.setLayout(GamePanelLayout);
        GamePanelLayout.setHorizontalGroup(
            GamePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 960, Short.MAX_VALUE)
        );
        GamePanelLayout.setVerticalGroup(
            GamePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 660, Short.MAX_VALUE)
        );

        Wall.setIcon(new javax.swing.ImageIcon(getClass().getResource("/biteme/wall.gif"))); // NOI18N
        Wall.setToolTipText(Messages.EDITOR_WALL_TOOLTIP);
        Wall.setActionCommand("wall");
        Wall.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        Wall.setPreferredSize(new java.awt.Dimension(30, 30));
        Wall.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                SetSelectedObjectWall(evt);
            }
        });

        OneWayD.setIcon(new javax.swing.ImageIcon(getClass().getResource("/biteme/OneWayD.gif"))); // NOI18N
        OneWayD.setToolTipText(Messages.EDITOR_DOWN_TOOLTIP);
        OneWayD.setActionCommand("OneWayD");
        OneWayD.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        OneWayD.setPreferredSize(new java.awt.Dimension(30, 30));
        OneWayD.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                SetSelectedObjectOneWayD(evt);
            }
        });

        OneWayL.setIcon(new javax.swing.ImageIcon(getClass().getResource("/biteme/OneWayL.gif"))); // NOI18N
        OneWayL.setToolTipText(Messages.EDITOR_LEFT_TOOLTIP);
        OneWayL.setActionCommand("OneWayL");
        OneWayL.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        OneWayL.setPreferredSize(new java.awt.Dimension(30, 30));
        OneWayL.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                SetSelectedObjectOneWayL(evt);
            }
        });

        OneWayR.setIcon(new javax.swing.ImageIcon(getClass().getResource("/biteme/OneWayR.gif"))); // NOI18N
        OneWayR.setToolTipText(Messages.EDITOR_RIGHT_TOOLTIP);
        OneWayR.setActionCommand("OneWayR");
        OneWayR.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        OneWayR.setPreferredSize(new java.awt.Dimension(30, 30));
        OneWayR.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                SetSelectedObjectOneWayR(evt);
            }
        });

        OneWayU.setIcon(new javax.swing.ImageIcon(getClass().getResource("/biteme/OneWayU.gif"))); // NOI18N
        OneWayU.setToolTipText(Messages.EDITOR_UP_TOOLTIP);
        OneWayU.setActionCommand("OneWayU");
        OneWayU.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        OneWayU.setPreferredSize(new java.awt.Dimension(30, 30));
        OneWayU.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                SetSelectedObjectOneWayU(evt);
            }
        });

        Pacman.setIcon(new javax.swing.ImageIcon(getClass().getResource("/biteme/PacmanL.gif"))); // NOI18N
        Pacman.setToolTipText(Messages.EDITOR_PACMAN_TOOLTIP);
        Pacman.setActionCommand("Pacman");
        Pacman.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        Pacman.setPreferredSize(new java.awt.Dimension(30, 30));
        Pacman.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                SetSelectedObjectPacman(evt);
            }
        });

        SmartGhost.setIcon(new javax.swing.ImageIcon(getClass().getResource("/biteme/SmartGhost.gif"))); // NOI18N
        SmartGhost.setToolTipText(Messages.EDITOR_SMART_TOOLTIP);
        SmartGhost.setActionCommand("SmartGhost");
        SmartGhost.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        SmartGhost.setPreferredSize(new java.awt.Dimension(30, 30));
        SmartGhost.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                SetSelectedObjectSmartGhost(evt);
            }
        });

        StupidGhost.setIcon(new javax.swing.ImageIcon(getClass().getResource("/biteme/StupidGhost.gif"))); // NOI18N
        StupidGhost.setToolTipText(Messages.EDITOR_STUPID_TOOLTIP);
        StupidGhost.setActionCommand("StupidGhost");
        StupidGhost.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        StupidGhost.setPreferredSize(new java.awt.Dimension(30, 30));
        StupidGhost.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                SetSelectedObjectStupidGhost(evt);
            }
        });

        Box.setIcon(new javax.swing.ImageIcon(getClass().getResource("/biteme/box.gif"))); // NOI18N
        Box.setToolTipText(Messages.EDITOR_BOX_TOOLTIP);
        Box.setActionCommand("Box");
        Box.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        Box.setPreferredSize(new java.awt.Dimension(30, 30));
        Box.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                SetSelectedObjectBox(evt);
            }
        });

        Coin.setIcon(new javax.swing.ImageIcon(getClass().getResource("/biteme/coin.gif"))); // NOI18N
        Coin.setToolTipText(Messages.EDITOR_COIN_TOOLTIP);
        Coin.setActionCommand("Coin");
        Coin.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        Coin.setPreferredSize(new java.awt.Dimension(30, 30));
        Coin.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                SetSelectedObjectCoin(evt);
            }
        });

        Empty.setIcon(new javax.swing.ImageIcon(getClass().getResource("/biteme/black.gif"))); // NOI18N
        Empty.setToolTipText(Messages.EDITOR_EMPTY_TOOLTIP);
        Empty.setActionCommand("Empty");
        Empty.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        Empty.setPreferredSize(new java.awt.Dimension(30, 30));
        Empty.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                SetSelectedObjectEmpty(evt);
            }
        });

        FillCoins.setIcon(new javax.swing.ImageIcon(getClass().getResource("/biteme/fillcoins.png"))); // NOI18N
        FillCoins.setToolTipText(Messages.EDITOR_FILL_COINS_TOOLTIP);
        FillCoins.setActionCommand("FillCoins");
        FillCoins.setMaximumSize(new java.awt.Dimension(150, 20));
        FillCoins.setMinimumSize(new java.awt.Dimension(150, 20));
        FillCoins.setPreferredSize(new java.awt.Dimension(150, 20));
        FillCoins.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                FillCoins(evt);
            }
        });

        MultipleWalls.setText("Multiple Walls");
        MultipleWalls.setToolTipText(Messages.EDITOR_MULTIPLE_WALLS_TOOLTIP);

        RemoveCoins.setIcon(new javax.swing.ImageIcon(getClass().getResource("/biteme/removecoins.png"))); // NOI18N
        RemoveCoins.setToolTipText(Messages.EDITOR_CLEAR_COINS_TOOLTIP);
        RemoveCoins.setActionCommand("RemoveCoins");
        RemoveCoins.setMaximumSize(new java.awt.Dimension(150, 20));
        RemoveCoins.setMinimumSize(new java.awt.Dimension(150, 20));
        RemoveCoins.setPreferredSize(new java.awt.Dimension(150, 20));
        RemoveCoins.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                RemoveCoins(evt);
            }
        });

        Test.setIcon(new javax.swing.ImageIcon(getClass().getResource("/biteme/test.png"))); // NOI18N
        Test.setActionCommand("Test");
        Test.setMaximumSize(new java.awt.Dimension(150, 20));
        Test.setMinimumSize(new java.awt.Dimension(150, 20));
        Test.setPreferredSize(new java.awt.Dimension(150, 20));
        Test.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                Test(evt);
            }
        });

        Load_File.setIcon(new javax.swing.ImageIcon(getClass().getResource("/biteme/load_file.png"))); // NOI18N
        Load_File.setActionCommand("LoadFile");
        Load_File.setMaximumSize(new java.awt.Dimension(150, 20));
        Load_File.setMinimumSize(new java.awt.Dimension(150, 20));
        Load_File.setPreferredSize(new java.awt.Dimension(150, 20));
        Load_File.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                LoadFile(evt);
            }
        });

        Reset.setIcon(new javax.swing.ImageIcon(getClass().getResource("/biteme/reset.png"))); // NOI18N
        Reset.setActionCommand("Reset");
        Reset.setMaximumSize(new java.awt.Dimension(150, 20));
        Reset.setMinimumSize(new java.awt.Dimension(150, 20));
        Reset.setPreferredSize(new java.awt.Dimension(150, 20));
        Reset.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                ResetMaze(evt);
            }
        });

        Temp_Save.setIcon(new javax.swing.ImageIcon(getClass().getResource("/biteme/temp_save.png"))); // NOI18N
        Temp_Save.setActionCommand("Temp_save");
        Temp_Save.setMaximumSize(new java.awt.Dimension(150, 20));
        Temp_Save.setMinimumSize(new java.awt.Dimension(150, 20));
        Temp_Save.setPreferredSize(new java.awt.Dimension(150, 20));
        Temp_Save.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                TempSaveMaze(evt);
            }
        });

        Main_Menu_button.setIcon(new javax.swing.ImageIcon(getClass().getResource("/biteme/main_menu.png"))); // NOI18N
        Main_Menu_button.setActionCommand("Main_Menu");
        Main_Menu_button.setMaximumSize(new java.awt.Dimension(150, 20));
        Main_Menu_button.setMinimumSize(new java.awt.Dimension(150, 20));
        Main_Menu_button.setPreferredSize(new java.awt.Dimension(150, 20));
        Main_Menu_button.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                MainMenu(evt);
            }
        });

        jButton1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/biteme/help.png"))); // NOI18N
        jButton1.setMaximumSize(new java.awt.Dimension(150, 20));
        jButton1.setMinimumSize(new java.awt.Dimension(150, 20));
        jButton1.setPreferredSize(new java.awt.Dimension(150, 20));
        jButton1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                jButton1MousePressed(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(Test, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addComponent(Load_File, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addComponent(Reset, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addComponent(Temp_Save, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addComponent(Main_Menu_button, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addComponent(jButton1, javax.swing.GroupLayout.DEFAULT_SIZE, 150, Short.MAX_VALUE)
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addComponent(Test, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(Load_File, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(Reset, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(Temp_Save, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(Main_Menu_button, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButton1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(82, 82, 82)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(Wall, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(OneWayD, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(OneWayL, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(OneWayR, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(OneWayU, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(Pacman, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(SmartGhost, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(StupidGhost, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(Box, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(Coin, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(Empty, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(FillCoins, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(RemoveCoins, javax.swing.GroupLayout.PREFERRED_SIZE, 142, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addComponent(MultipleWalls)))
                    .addComponent(GamePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(50, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(GamePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(26, 26, 26)
                        .addComponent(MultipleWalls)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(Wall, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(OneWayD, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(OneWayL, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(OneWayR, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(OneWayU, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(Pacman, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(SmartGhost, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(StupidGhost, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(Box, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(Coin, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(Empty, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                .addComponent(FillCoins, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addComponent(RemoveCoins, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))))
                    .addGroup(layout.createSequentialGroup()
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void MainMenu(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_MainMenu
        // terug naar het hoofdmenu
        if (Popup.yesno(Messages.EDITOR_POPUP_EXIT) == 0) {
            MainMenu mainmenu = new MainMenu(null);
            mainmenu.setVisible(true);
            setVisible(false);
        }

    }//GEN-LAST:event_MainMenu

    private void SetSelectedObjectOneWayD(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_SetSelectedObjectOneWayD
        selectedTileType = EditorTileType.ONE_WAY_DOWN;
        Wall.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        OneWayD.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        OneWayL.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        OneWayR.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        OneWayU.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        Pacman.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        SmartGhost.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        StupidGhost.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        Box.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        Coin.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        Empty.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
    }//GEN-LAST:event_SetSelectedObjectOneWayD

    private void SetSelectedObjectOneWayL(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_SetSelectedObjectOneWayL
        selectedTileType = EditorTileType.ONE_WAY_LEFT;
        Wall.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        OneWayD.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        OneWayL.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        OneWayR.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        OneWayU.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        Pacman.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        SmartGhost.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        StupidGhost.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        Box.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        Coin.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        Empty.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
    }//GEN-LAST:event_SetSelectedObjectOneWayL

    private void SetSelectedObjectOneWayR(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_SetSelectedObjectOneWayR
        selectedTileType = EditorTileType.ONE_WAY_RIGHT;
        Wall.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        OneWayD.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        OneWayL.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        OneWayR.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        OneWayU.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        Pacman.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        SmartGhost.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        StupidGhost.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        Box.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        Coin.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        Empty.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
    }//GEN-LAST:event_SetSelectedObjectOneWayR

    private void SetSelectedObjectOneWayU(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_SetSelectedObjectOneWayU
        selectedTileType = EditorTileType.ONE_WAY_UP;
        Wall.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        OneWayD.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        OneWayL.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        OneWayR.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        OneWayU.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        Pacman.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        SmartGhost.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        StupidGhost.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        Box.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        Coin.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        Empty.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
    }//GEN-LAST:event_SetSelectedObjectOneWayU

    private void SetSelectedObjectPacman(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_SetSelectedObjectPacman
        selectedTileType = EditorTileType.PACMAN;
        Wall.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        OneWayD.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        OneWayL.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        OneWayR.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        OneWayU.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        Pacman.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        SmartGhost.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        StupidGhost.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        Box.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        Coin.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        Empty.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
    }//GEN-LAST:event_SetSelectedObjectPacman

    private void SetSelectedObjectSmartGhost(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_SetSelectedObjectSmartGhost
        selectedTileType = EditorTileType.SMART_GHOST;
        Wall.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        OneWayD.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        OneWayL.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        OneWayR.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        OneWayU.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        Pacman.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        SmartGhost.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        StupidGhost.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        Box.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        Coin.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        Empty.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
    }//GEN-LAST:event_SetSelectedObjectSmartGhost

    private void SetSelectedObjectStupidGhost(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_SetSelectedObjectStupidGhost
        selectedTileType = EditorTileType.STUPID_GHOST;
        Wall.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        OneWayD.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        OneWayL.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        OneWayR.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        OneWayU.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        Pacman.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        SmartGhost.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        StupidGhost.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        Box.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        Coin.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        Empty.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
    }//GEN-LAST:event_SetSelectedObjectStupidGhost

    private void SetSelectedObjectBox(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_SetSelectedObjectBox
        selectedTileType = EditorTileType.BOX;
        Wall.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        OneWayD.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        OneWayL.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        OneWayR.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        OneWayU.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        Pacman.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        SmartGhost.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        StupidGhost.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        Box.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        Coin.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        Empty.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
    }//GEN-LAST:event_SetSelectedObjectBox

    private void SetSelectedObjectCoin(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_SetSelectedObjectCoin
        selectedTileType = EditorTileType.COIN;
        Wall.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        OneWayD.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        OneWayL.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        OneWayR.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        OneWayU.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        Pacman.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        SmartGhost.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        StupidGhost.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        Box.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        Coin.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        Empty.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
    }//GEN-LAST:event_SetSelectedObjectCoin

    private void SetSelectedObjectEmpty(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_SetSelectedObjectEmpty
        selectedTileType = EditorTileType.NONE;
        Wall.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        OneWayD.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        OneWayL.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        OneWayR.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        OneWayU.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        Pacman.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        SmartGhost.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        StupidGhost.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        Box.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        Coin.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        Empty.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
    }//GEN-LAST:event_SetSelectedObjectEmpty

    private void TempSaveMaze(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_TempSaveMaze
        // slaat het level tot nu toe op
        if (currentMazePath == null) {
            String mazename = Popup.savecancel("Enter a name for your maze","Enter Name");
            if (mazename != null && !mazename.isEmpty() && !mazename.equals("Enter Name") && !MazeIO.doesFileExist(Path.getMazesPath() + mazename)) {
                currentMazePath = Path.getMazesPath() + mazename + ".unp";
                currentMazeName = mazename;
                MazeIO.saveMaze(GamePanel, new ScoreList("all"), new ScoreList("week"), new ScoreList("day"), currentMazePath);
                setTitle(currentMazeName);
            } else if (mazename != null && (mazename.isEmpty() || mazename.equals("Enter Name"))) {
                Popup.ok(Messages.EDITOR_POPUP_NO_LEVEL_NAME);
            } else if (mazename != null && !mazename.isEmpty() && MazeIO.doesFileExist(Path.getMazesPath() + mazename)) {
                if (Popup.yesno(Messages.EDITOR_POPUP_OVERWRITE) == 0) {
                    currentMazePath = Path.getMazesPath() + mazename + ".unp";
                    currentMazeName = mazename;
                    MazeIO.saveMaze(GamePanel, new ScoreList("all"), new ScoreList("week"), new ScoreList("day"), currentMazePath);
                    Popup.ok(currentMazeName +" is now saved.");
                }
            }
        } else {
            MazeIO.saveMaze(GamePanel, new ScoreList("all"), new ScoreList("week"), new ScoreList("day"),
                    currentMazePath);
            Popup.ok(currentMazeName +" is now saved.");
        }
    }//GEN-LAST:event_TempSaveMaze

    private void LoadFile(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_LoadFile
        LevelSelectEditor levelselect = new LevelSelectEditor(this);
        levelselect.setVisible(true);
        this.setVisible(false);
    }//GEN-LAST:event_LoadFile

    private void Test(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_Test
        // gemaakte level (saven en) testen
        // er moet natuurlijk wel een pacman bestaan EN MINIMAAL 1 COIN
        if (GamePanel.getPacman() != null && GamePanel.getCoinCount() != 0 && currentMazePath != null) {
            MazeIO.saveMaze(GamePanel, new ScoreList("all"), new ScoreList("week"), new ScoreList("day"), currentMazePath);
            GameGUI gameGUI = new GameGUI(this, currentMazePath);
            gameGUI.setVisible(true);
            this.setVisible(false);
        } else if (GamePanel.getPacman() == null) {
            Popup.ok(Messages.EDITOR_POPUP_NOPACMAN);
        } else if (GamePanel.getCoinCount() == 0) {
            Popup.ok(Messages.EDITOR_POPUP_NOCOINS);
            //if there is no filename yet, first it asks for one
        } else if (currentMazePath == null) {
            String mazename = Popup.savecancel(Messages.EDITOR_POPUP_LEVEL_NAME,"Enter Name");
            if (mazename != null && !mazename.isEmpty() && !mazename.equals("Enter Name") && !MazeIO.doesFileExist(Path.getMazesPath() + mazename)) {
                mazename = Path.getMazesPath() + mazename + ".unp";
                currentMazePath = mazename;
                currentMazeName = MazeIO.getFileName(mazename);
                if (currentMazeName != null) {
                    setTitle(currentMazeName);
                }
                MazeIO.saveMaze(GamePanel, new ScoreList("all"), new ScoreList("week"), new ScoreList("day"), currentMazePath);
                GameGUI gameGUI = new GameGUI(this, currentMazePath);
                gameGUI.setVisible(true);
                this.setVisible(false);
            } else if (mazename != null && (mazename.isEmpty() || mazename.equals("Enter Name"))) {
                Popup.ok(Messages.EDITOR_POPUP_NO_LEVEL_NAME);
            } else if (mazename != null && !mazename.isEmpty() && MazeIO.doesFileExist(Path.getMazesPath() + mazename)) {
                if (Popup.yesno(Messages.EDITOR_POPUP_OVERWRITE) == 0) {
                    currentMazePath = Path.getMazesPath() + mazename + ".unp";
                    currentMazeName = mazename;
                    MazeIO.saveMaze(GamePanel, new ScoreList("all"), new ScoreList("week"), new ScoreList("day"), currentMazePath);
                    GameGUI gameGUI = new GameGUI(this, currentMazePath);
                    gameGUI.setVisible(true);
                    this.setVisible(false);
                }                
            }
        }
    }//GEN-LAST:event_Test

    private void ResetMaze(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_ResetMaze
        if (Popup.yesno(Messages.EDITOR_POPUP_RESET) == 0) {
            GamePanel.clear();
            GamePanel.initialDraw();
        }
    }//GEN-LAST:event_ResetMaze

    private void FillCoins(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_FillCoins
        // plaats een coin op elke lege of oneway tile
        for (Tile t : GamePanel.getTiles()) {
            if (t.getStatus().containsNothing() || (t instanceof OneWayTile && !t.getStatus().containsCoin())) {
                t.getStatus().toggleCoin();
            }
        }
        GamePanel.initialDraw();
    }//GEN-LAST:event_FillCoins

    private void SetSelectedObjectWall(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_SetSelectedObjectWall
        selectedTileType = EditorTileType.WALL;
        Wall.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        OneWayD.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        OneWayL.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        OneWayR.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        OneWayU.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        Pacman.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        SmartGhost.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        StupidGhost.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        Box.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        Coin.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        Empty.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
}//GEN-LAST:event_SetSelectedObjectWall

    private void RemoveCoins(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_RemoveCoins
        // plaats een coin op elke lege of oneway tile
        for (Tile t : GamePanel.getTiles()) {
            t.getStatus().clearCoin();
        }
        GamePanel.initialDraw();
    }//GEN-LAST:event_RemoveCoins

    private void jButton1MousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton1MousePressed
        Popup.help(1);
    }//GEN-LAST:event_jButton1MousePressed
    /**
     * @param args the command line arguments
     */
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton Box;
    private javax.swing.JButton Coin;
    private javax.swing.JButton Empty;
    private javax.swing.JButton FillCoins;
    private biteme.Maze GamePanel;
    private javax.swing.JButton Load_File;
    private javax.swing.JButton Main_Menu_button;
    private javax.swing.JCheckBox MultipleWalls;
    private javax.swing.JButton OneWayD;
    private javax.swing.JButton OneWayL;
    private javax.swing.JButton OneWayR;
    private javax.swing.JButton OneWayU;
    private javax.swing.JButton Pacman;
    private javax.swing.JButton RemoveCoins;
    private javax.swing.JButton Reset;
    private javax.swing.JButton SmartGhost;
    private javax.swing.JButton StupidGhost;
    private javax.swing.JButton Temp_Save;
    private javax.swing.JButton Test;
    private javax.swing.JButton Wall;
    private javax.swing.JButton jButton1;
    private javax.swing.JPanel jPanel1;
    // End of variables declaration//GEN-END:variables
}
