package biteme;



import java.util.Calendar;


/**Structure for storing and maintaining list of highscores
 *
 * @author J.H. van der Aa
 */
public class ScoreList {
    int days;
    String ListType;
    HighScore[] scores = new HighScore[10];

        /**
     * Constructor, sets the number of days the list should look back for results
     * @param listType the type of scorelist; day, week, all
     */
 public ScoreList(String listType){
     if (listType.equals("day")){
         days = 1;
     } else if (listType.equals("week")){
         days = 7;
     } else days = 9999999;

    //set standard scores for the array
     for (int i = 0; i < 10; i++){
         scores[i] = new HighScore();
     }
     ListType = listType;

 }

   /**
     * 
     * 
    * @return the type of the scorelist
    */
 public String getType(){
     return ListType;
 }
   /**
     * 
    * @param position the posistion of the score in the scorelist
    * @return the requested HighScore
     */
 public HighScore getScore(int position){
     return scores[position - 1];
 }

  /**
     * edits a highscore
   * @param position the posistion of the score in the scorelist
   * @param name the new username for this score
   * @param date the date of the new score
   * @param score the new value for score
     */
 public void editScore(int position, String name, int score, Calendar date){
     scores[position-1].setScore(score, name, date);

 }

   /**
     * removes dates that are no longer in the daterange of the highscore
     */
 public void updateList(){
      Calendar limitDate = Calendar.getInstance();

      if (days == 1){
            for (int i = 1; i < 11; i++){
            if (this.getScore(i).getDate().before(limitDate)) {
                this.editScore(i, "Name", Integer.MAX_VALUE, Calendar.getInstance());
            }
          }
      }
      if (days == 7){
          if (limitDate.get(Calendar.DATE) <= 7){
              if (limitDate.get(Calendar.MONTH) == 0){
                  limitDate.roll(Calendar.YEAR, -1);
              }
              limitDate.roll(Calendar.MONTH, -1);
          }
          limitDate.roll(Calendar.DATE, -(days-1));
          for (int i = 1; i < 11; i++){
              if (this.getScore(i).getDate().before(limitDate)) {
                  this.editScore(i, "Name", Integer.MAX_VALUE, Calendar.getInstance());
            
              }
          }
      }
 }

    /**
     * sorts the  list based on the scores
     */
 public void sortList(){
     HighScore tempBest;
     int bestindex;
     for (int i = 1; i < 11; i ++){
         tempBest = this.getScore(i);
         bestindex = i-1;
         for (int j = i; j < 11; j++){
             if (this.getScore(j).getScore() < tempBest.getScore() ){
                 tempBest = this.getScore(j);
                 bestindex = j-1;
             }

         }
         scores[bestindex] = scores[i-1];
         scores[i-1] = tempBest;

         
     }
     
 }

}