/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package biteme;

/**
 * Class containing static methods for playing different sounds in separate threads.
 * @author N.F.W. Thissen
 */
public class Sound {

    /** Thread that plays the Pacman move sound. */
    private static SoundThread pacmanMoveSoundThread = new SoundThread(Path.getSoundsPath() + "eating.short.wav");
    /** Thread that plays the intro music. */
    private static SoundThread introSoundThread = new SoundThread(Path.getSoundsPath() + "opening_song.wav");
    /** Thread that plays the pause music. */
    private static SoundThread pauseSoundThread = new SoundThread(Path.getSoundsPath() + "intermission.wav");
    /** Thread that plays the Pacman dying sound. */
    private static SoundThread pacmanDiesSoundThread = new SoundThread(Path.getSoundsPath() + "pacman_dies.wav");
    /** Thread that plays the winning sound. */
    private static SoundThread winSoundThread = new SoundThread(Path.getSoundsPath() + "extra_lives.wav");

    /** Plays the Pacman moving sound once in a separate thread. */
    public static void playPacmanMoving() {
        if (!pacmanMoveSoundThread.isAlive()) {
            pacmanMoveSoundThread = new SoundThread(Path.getSoundsPath() + "eating.short.wav");
            pacmanMoveSoundThread.start();
        }
    }

    /** Plays the Pacman dying sound once in a separate thread. */
    public static void playPacmanDying() {
        if (!pacmanDiesSoundThread.isAlive()) {
            pacmanDiesSoundThread = new SoundThread(Path.getSoundsPath() + "pacman_dies.wav");
            pacmanDiesSoundThread.start();
        }
    }

    /** Plays the intro music once in a separate thread. */
    public static void playIntro() {
        if (!introSoundThread.isAlive()) {
            introSoundThread = new SoundThread(Path.getSoundsPath() + "opening_song.wav");
            introSoundThread.start();
        }
    }

    /** Plays the pause music once in a separate thread. */
    public static void playPause() {
        if (!pauseSoundThread.isAlive()) {
            pauseSoundThread = new SoundThread(Path.getSoundsPath() + "intermission.wav");
            pauseSoundThread.start();
        }
    }

    /** Plays the winning sound once in a separate thread. */
    public static void playWin() {
        if (!winSoundThread.isAlive()) {
            winSoundThread = new SoundThread(Path.getSoundsPath() + "extra_lives.wav");
            winSoundThread.start();
        }
    }

}
